#!/bin/env ruby
# encoding: utf-8

module Grubber
  class Presenter

    attr_accessor :restaurants

    def initialize(restaurants)
      @restaurants = [*restaurants]
    end

    def present
      return nil if empty?

      restaurants.each do |r|
        puts "\n#{r.name} #{stars(r.rating)}"
        puts r.address
        puts "[#{r.category}] #{r.phone}"
        puts r.url
      end
      nil
    end

    def stars(rating)
      (" ★" * rating) + (" ☆" * (5 - rating))
    end

    def empty?
      self.restaurants.empty?
    end

  end
end
