module Grubber
  class Restaurant
    
    ATTRIBUTES = [:name, :description, :categories, :rating, :url, :display_phone, :location, :reviews].freeze
    attr_accessor *ATTRIBUTES

    alias_method :phone, :display_phone

    def initialize(opts={})
      opts.each_pair do |k,v|
        self.instance_variable_set("@#{k}", v)
      end
      yield self
    end
    
    def self.all(opts={})
      q = opts[:term] || 'lunch'
      Client.new.search(q)
    end

    def self.random(opts={})
      all(opts).sample
    end

    def address
      location['display_address'].first
    end

    def category
      cat = categories.first
      cat.is_a?(Array) ? cat.first : cat
    end

    def self.parse(body)
      JSON.parse(body)['businesses'].collect do |r|
        Restaurant.new do |n|
          ATTRIBUTES.map(&:to_s).each do |a|
            value = r[a]
            value = value.to_i if a == 'rating'
            n.send("#{a}=", value)
          end
        end
      end
    end

  end
end
